lexer grammar AspectC;
options {
  language=Java;

}
@header {
  package de.sm.aspectc;
}

ADVICE : 'advice' ;
ASPECT : 'aspect' ;
POINTCUT : 'pointcut' ;
STATIC : 'static' ;
EXTERN : 'extern' ;
CONST : 'const' ;
HEXPREFIX : '0x' ;
RESTRICT : 'restrict' ;

// $ANTLR src "/VMADL.j/src/de/sm/aspectc/AspectC.g" 114
IDENTIFIER : LETTER ( DIGIT | LETTER | '-' | '_' )*;

// $ANTLR src "/VMADL.j/src/de/sm/aspectc/AspectC.g" 116
DIGIT
    :    '0'..'9'
    ;
// $ANTLR src "/VMADL.j/src/de/sm/aspectc/AspectC.g" 119
fragment LETTER
    : 'a'..'z'
    | 'A'..'Z'
    ;

// $ANTLR src "/VMADL.j/src/de/sm/aspectc/AspectC.g" 124
LPARENTHESIS: '(';
// $ANTLR src "/VMADL.j/src/de/sm/aspectc/AspectC.g" 125
RPARENTHESIS: ')';

// $ANTLR src "/VMADL.j/src/de/sm/aspectc/AspectC.g" 127
SPECIAL : ':' | '='| '.' | '*' | '+' | '%' | '/' | '\\'
	| '_' | ',' | '|' | '&' | '-' | '"' | '<' | '>' | '[' | ']' | '!' | '\'' | '?' ;

// $ANTLR src "/VMADL.j/src/de/sm/aspectc/AspectC.g" 130
PPCONTINUE: '\\' NEWLINE;

// $ANTLR src "/VMADL.j/src/de/sm/aspectc/AspectC.g" 132
NEWLINE
  : '\r'? '\n'
  //{ channel=HIDDEN; }
;

// $ANTLR src "/VMADL.j/src/de/sm/aspectc/AspectC.g" 137
WS
  : (' '|'\t')+		//|'\n'|'\r' 
  { channel=HIDDEN; }
;

// $ANTLR src "/VMADL.j/src/de/sm/aspectc/AspectC.g" 142
COMMENT
  : '//' (~('\n'|'\r'))* NEWLINE
  { channel=HIDDEN; }
;
  
// multiple-line comments
// $ANTLR src "/VMADL.j/src/de/sm/aspectc/AspectC.g" 148
ML_COMMENT
  : '/*' (options {greedy=false;} : .)* '*/' 
  { channel=HIDDEN; }
;

// $ANTLR src "/VMADL.j/src/de/sm/aspectc/AspectC.g" 153
HASH : '#';
// $ANTLR src "/VMADL.j/src/de/sm/aspectc/AspectC.g" 154
SEMICOLON : ';';
// $ANTLR src "/VMADL.j/src/de/sm/aspectc/AspectC.g" 155
LBRACE : '{';
// $ANTLR src "/VMADL.j/src/de/sm/aspectc/AspectC.g" 156
RBRACE : '}';
