lexer grammar CSimple;
options {
  language=Java;

}
@members {
  private int lineCount = 0;
  
  public int getLineCount() {
    return lineCount;
  }
}
@header {
  package de.sm.csimple;
}

TYPEDEF : 'typedef' ;
STRUCT : 'struct' ;
STATIC : 'static' ;
INLINE : 'inline' ;
EXTERN : 'extern' ;
CONST : 'const' ;
ATTR : '__attribute__' ;
HEXPREFIX : '0x' ;
T24 : '[' ;
T25 : ']' ;
T26 : '=' ;
T27 : ';' ;
T28 : '#' ;
T29 : '(' ;
T30 : ')' ;
T31 : '*' ;
T32 : 'a' ;
T33 : 'f' ;
T34 : 'A' ;
T35 : 'F' ;

// $ANTLR src "/VMADL.j/src/de/sm/csimple/CSimple.g" 149
SPECIAL : '(' | ')' | ':' | '='| '.' | '*' | '+' | '%' | '#' | '/' | '\\' | '^' | '?' | '@' | '$'
	| '_' | ';' | ',' | '|' | '&' | '-' | '<' | '>' | '[' | ']' | '!' | '\'' | '~' ;

// $ANTLR src "/VMADL.j/src/de/sm/csimple/CSimple.g" 152
IDENTIFIER : (LETTER | '_') ( DIGIT | LETTER | '_' )*;

// $ANTLR src "/VMADL.j/src/de/sm/csimple/CSimple.g" 154
DIGIT
    :    '0'..'9'
    ;
// $ANTLR src "/VMADL.j/src/de/sm/csimple/CSimple.g" 157
fragment LETTER
    : 'a'..'z'
    | 'A'..'Z'
    ;

// $ANTLR src "/VMADL.j/src/de/sm/csimple/CSimple.g" 162
PPCONTINUE: '\\' NEWLINE;

// $ANTLR src "/VMADL.j/src/de/sm/csimple/CSimple.g" 164
NEWLINE
  : '\r'? '\n'
  { lineCount++; }
  //{ channel=HIDDEN; }
;

// $ANTLR src "/VMADL.j/src/de/sm/csimple/CSimple.g" 170
WS
  : (' '|'\t')+		//|'\n'|'\r' 
  { channel=HIDDEN; }
;

// $ANTLR src "/VMADL.j/src/de/sm/csimple/CSimple.g" 175
COMMENT
  : '//' (~('\n'|'\r'))* NEWLINE
  { channel=HIDDEN; }
;
  
// multiple-line comments
// $ANTLR src "/VMADL.j/src/de/sm/csimple/CSimple.g" 181
ML_COMMENT
  : '/*' (options {greedy=false;} : .)* '*/' 
  { channel=HIDDEN; }
;

// $ANTLR src "/VMADL.j/src/de/sm/csimple/CSimple.g" 186
QUOTE  : '"';
// $ANTLR src "/VMADL.j/src/de/sm/csimple/CSimple.g" 187
LBRACE : '{';
// $ANTLR src "/VMADL.j/src/de/sm/csimple/CSimple.g" 188
RBRACE : '}';