package de.sm.metrics;

import java.io.File;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ConceptualModule extends Module {
	
	private Map<File, Module> subModules;
	
	public ConceptualModule(File file) {
		super(file);
		subModules = new HashMap<File, Module>();
	}
	
	public void addSubModul(Module module) {
		subModules.put(module.getFile(), module);
	}
	
	public int getSubModuleCount() {
		return subModules.size();
	}

	@Override
	public int getLinesOfCode() {
		int loc = 0;
		
		for (Module m : subModules.values()) {
			loc += m.getLinesOfCode();
		}
		
		return loc;
	}

	@Override
	public int getLinesOfCodeWithStatements() {
		int loc = 0;
		
		for (Module m : subModules.values()) {
			loc += m.getLinesOfCodeWithStatements();
		}
		
		return loc;
	}

	public Collection<Module> getSubModules() {
		return subModules.values();
	}
	
	
	
}
