package de.sm.metrics;

public class Presenter {

	private ModuleRegistry reg;

	public Presenter(ModuleRegistry reg) {
		this.reg = reg;
	}

	public void showMetrics() {
		System.out.println("ModuleName;LoC;LoCWS;SMC;Path;Func;FuncSig;Prepro;Typedef;Var;Struct;Advices;Pointcuts;Combine;Declarations;Types;Type");
		printMetrics((Module) reg.getRoot());
		
		//System.out.println(m.getLinesOfCode());
		//System.out.println(m.getLinesOfCodeWithStatements());
	}
	
	private void printMetrics(ConceptualModule module) {
		System.out.println(";;;;;;;;;;;;C");
		for (Module m : module.getSubModules()) {
			printMetrics(m);
		}
	}
	
	private void printMetrics(Module module) {
		System.out.print(module.getName() + ";" + module.getLinesOfCode()
				+ ";" + module.getLinesOfCodeWithStatements()
				+ ";" + module.getSubModuleCount()
				+ ";" + module.getFile().getAbsolutePath());
		
		if (module instanceof ImplementationModule) {
			printMetrics((ImplementationModule) module);
		} else {
			printMetrics((ConceptualModule) module);
		}
	}
	
	private void printMetrics(ImplementationModule module) {
		System.out.print(";" + module.getFunctionCount()
				+ ";" + module.getFunctionSigCount()
				+ ";" + module.getPreprocessorCount()
				+ ";" + module.getTypedefCount()
				+ ";" + module.getVariableCount()
				+ ";" + module.getStructCount()
				);
		
		System.out.print(";" + module.getAdviceCount()
				+ ";" + module.getPointcutCount()
				);
		System.out.print(";" + module.getCombineCount()
				+ ";" + module.getDeclarationCount()
				+ ";" + module.getTypeCount()
				);
		
		System.out.println(";I");
	}

}
