package de.sm.odl.elements;

import java.util.ArrayList;
import java.util.List;

import de.sm.vmadl.elements.ServiceModule;

public abstract class Type implements Cloneable {
	private ServiceModule module;
	private String name;
	private Type baseclass;
	private List<TraitType> traits = new ArrayList<TraitType>();
	private List<Field> fields = new ArrayList<Field>();
	private List<Function> functions = new ArrayList<Function>();
	
	public void setModule(ServiceModule module) {
		this.module = module;
	}
	
	public ServiceModule getModule() {
		return module;
	}
	
	public void setName(String name) {
		this.name = name.intern();
	}
	
	public String getName() {
		return name;
	}
	
	public void setBaseclass(Type baseclass) {
		this.baseclass = baseclass;
	}
	
	public Type getBaseclass() {
		return baseclass;
	}
	
	public void addTrait(TraitType type) {
		traits.add(type);
	}
	
	public List<TraitType> getTraits() {
		return traits;
	}
	
	public void addField(Field field) {
		fields.add(field);
	}
	
	public List<Field> getFields() {
		return fields;
	}
	
	public void addFunction(Function func) {
		functions.add(func);
	}
	
	public List<Function> getFunctions() {
		return functions;
	}
	
	@Override
	public Object clone() throws CloneNotSupportedException {
		Type o = (Type)super.clone();
		
		o.fields = new ArrayList<Field>(fields);
		o.functions = new ArrayList<Function>(functions);
		o.traits = new ArrayList<TraitType>(traits);
		
		return o;
	}
}
