#!/bin/bash
echo "["`date --rfc-3339=ns`"] Compilation of `basename $PWD` started." >> build.log

SUC_BUILD=""
FAILD_BUILD=""
SUC_TEST=""
FAILD_TEST=""

for dir in $( ls --hide "build.*" ); do
	cd $dir
	make clobber
	echo -e "["`date --rfc-3339=ns`"] $dir \t: Compilation Started" >> ../build.log
	make
	echo -en "["`date --rfc-3339=ns`"] $dir \t: Compilation " >> ../build.log
	if [ "$?" -eq 0 ]; then
		echo succeeded >> ../build.log
		SUC_BUILD="$SUC_BUILD $dir"
	else
		echo failed >> ../build.log
		FAILD_BUILD="$FAILD_BUILD $dir"
	fi

	make test
	echo -en "["`date --rfc-3339=ns`"] $dir \t: Test " >> ../build.log
	if [ "$?" -eq 0 ]; then
		echo succeeded >> ../build.log
		SUC_TEST="$SUC_TEST $dir"
	else
		echo failed >> ../build.log
		FAILD_TEST="$FAILD_TEST $dir"
	fi
	#make bench
	cd ..
done

echo "["`date --rfc-3339=ns`"] Successful Builds: $SUC_BUILD" >> build.log
echo "["`date --rfc-3339=ns`"] Successful Tests:  $SUC_TEST" >> build.log
echo "["`date --rfc-3339=ns`"] Failed Builds:     $FAILD_BUILD" >> build.log
echo "["`date --rfc-3339=ns`"] Failed Tests:      $FAILD_TEST" >> build.log
