#ifndef VMSIGNAL_H_
#define VMSIGNAL_H_

/* Native multi-threading for CSOM - Signal primitive class
 * 
 * Copyright (C) 2007 by Martin Beck and Jan Klimke
 * 
 * created 2007-05-09
 */

#include <vmobjects/VMObject.h>

#include <native/VMMutex.h>

#include <pthread.h>

typedef pthread_cond_t SignalId, *pSignalId;

#pragma mark VTable definition

VTABLE(VMSignal) {
#define VMSIGNAL_VTABLE_FORMAT \
    VMOBJECT_VTABLE_FORMAT; \
    pSignalId (*get_embedded_signal_id)(pVMSignal); \
    pMutexId  (*get_embedded_mutex_id)(pVMSignal); \
    void      (*wait)(pVMSignal); \
    void      (*signal)(pVMSignal); \
    bool      (*signal_all)(pVMSignal)
    
    VMSIGNAL_VTABLE_FORMAT;
};

#pragma mark class definition

struct _VMSignal {
    VTABLE(VMSignal) *_vtable;
#define VMSIGNAL_FORMAT \
    VMOBJECT_FORMAT; \
    SignalId embedded_signal_id; \
    MutexId embedded_mutex_id
    
    VMSIGNAL_FORMAT;
};

#pragma mark class methods

pVMSignal VMSignal_new(void);

#pragma mark vtable initialization

VTABLE(VMSignal) *VMSignal_vtable(void);

#endif /*VMSIGNAL_H_*/
