#ifndef CORE_BLOCK_H_
#define CORE_BLOCK_H_

/*
 *
Copyright (c) 2007 Michael Haupt, Tobias Pape
Software Architecture Group, Hasso Plattner Institute, Potsdam, Germany
http://www.hpi.uni-potsdam.de/swa/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
  */

#include <vmobjects/OOObject.h>

extern "C" {
	
void  _Block_value(pVMObject object, pVMFrame frame);
void  _Block_restart(pVMObject object, pVMFrame frame);
void  _Block_value_(pVMObject object, pVMFrame frame);
void  _Block_value_with_(pVMObject object, pVMFrame frame);

/* Creates a new Thread Object evaluating the Block                                                                         
 * Pushes the newly created Thread object onto the CSOM Stack                                                               
 */                                                                                                                         
void _Block_spawn(pVMObject object, pVMFrame frame);                                                                          
/* Creates a new thread with passing the given Argument to the Thread */                                                    
void _Block_spawnWithArgument_(pVMObject object, pVMFrame frame);

}

#endif CORE_BLOCK_H_
