#!/usr/bin/php
<?php
error_reporting(E_ALL);

$successLog = fopen('succ-compare.log', 'a');
$benchmarks = array('IntegerLoop', 'Fibonacci', 'Dispatch', 'Bounce', 'Loop', 'Permute', 'Queens', 'List', 'Recurse',
        'Storage', 'Sieve', 'BubbleSort', 'QuickSort', 'Sum', 'Towers', 'TreeSort', 'Threads');

chdir("odl");

$combinations = array( array(), 
		       array('marksweep'), 
		       array('green'), 
		       array('marksweep', 'image'),
		       array('native'),
		       array('refcount'),
		       array('marksweep', 'int-one'),
		       array('marksweep', 'threaded')
		     );

foreach ($combinations as $combination) {
  echo '['.date(DATE_ATOM).'] ';
  echo "Build with following features: ".join(', ', $combination)."\n";

  exec('make clobber');
  if (!empty($combination)) {
    exec('./configure '.join(' ', $combination));
  }
  $idString = trim(join('-', $combination));
  $binName = (empty($idString)?'plain':$idString);
  $logId = '../compare-log/'.$binName;

  exec('make prepare > '.$logId.'.prepare.log 2>&1');
  exec('make > '.$logId.'.make.log 2>&1', $out, $returnValue);
  if ($returnValue == 0) {
    echo '['.date(DATE_ATOM).'] '; echo "Build Succeeded\n";

    fwrite($successLog, '['.date(DATE_ATOM).'] make with '.join(' ', $combination)."\n");
    fflush($successLog);

    /*exec('make test > '.$logId.'.test.log 2>&1', $out, $returnValue);
    if ($returnValue == 0) {
      echo '['.date(DATE_ATOM).'] '; echo "Test Succeeded\n";
      fwrite($successLog, '['.date(DATE_ATOM).'] test with '.join(' ', $combination)."\n");
      fflush($successLog);
    } else {
      echo '['.date(DATE_ATOM).'] ';
      echo "Tests FAILED\n";
    }*/

    exec('mv bin ../vmadl-'.$binName);
    fwrite($successLog, '['.date(DATE_ATOM).'] Moved build into vmadl-'."$binName\n");
    fflush($successLog);

    /*exec('make bench > '.$logId.'.prepare.log 2>&1', $out, $returnValue);
    if ($returnValue == 0) {
      echo '['.date(DATE_ATOM).'] '; echo "Benchmarks succeeded\n";
      fwrite($successLog, '['.date(DATE_ATOM).'] bench with '.join(' ', $combination)."\n");
      fflush($successLog);
    } else {
      echo '['.date(DATE_ATOM).'] ';
      echo "Benchmarks FAILED\n";
    }*/

    /*$oldPath = getcwd();
    chdir('bin');
    echo "Run Eval Benchmarks\n";
    exec("./CSOM -cp Smalltalk Examples/Benchmarks/All.som > ../$logId.bench.log");
    foreach($benchmarks as $bench) {
        echo "Benchmark: $bench\n";
        for ($i = 0; $i < 10; $i++) {
          echo "$i";
          exec("./CSOM -cp Smalltalk Examples/Benchmarks/$bench.som >> ../$logId.$bench.log");
        }
        echo "\n";
    }*/

    chdir($oldPath);

  } else {
    echo '['.date(DATE_ATOM).'] ';
    echo "Build FAILED\n";
  }
}

fclose($successLog);
