#include <module.VMObjects>
#include <module.VM>

int _VMMethod_get_number_of_tcodes(void* _self) {
	pVMMethod self = (pVMMethod)_self;
    if (self->bytecodes_length)
        return SEND(self->bytecodes_length, get_embedded_integer);
    else  // no integer there
        return -1;
}

void* _VMMethod_get_tcode(void* _self, size_t index) {
	pVMMethod self = (pVMMethod)_self;
	bytecode_t* bytecodes;
    #ifdef DEBUG
        if(index >= SEND(self->bytecodes_length, get_embedded_integer))
            Universe_error_exit("[get] Method Threadedcode Index out of range.");
    #endif DEBUG
    /*
     * Bytecodes start at end of the internal array,
     * thus, at offset + number_of_constants
     */
	bytecodes = ((bytecode_t*)&self->fields[SEND(self, _get_offset) + 
			SEND(self, get_number_of_indexable_fields)
			]);	
    return ((void**)&(bytecodes[
		SEND(self, get_number_of_bytecodes)
    ]))[index];
}

void _VMMethod_set_tcode(void* _self, size_t index, void* value) {
	pVMMethod self = (pVMMethod)_self;
	bytecode_t* bytecodes;
	//int i;
    #ifdef DEBUG
        if(index >= SEND(self->bytecodes_length, get_embedded_integer))
           Universe_error_exit("[set] Method Threaded Index out of range.");  
    #endif DEBUG
    /*
     * Bytecodes start at end of the internal array,
     * thus, at offset + number_of_constants
     */ 
		bytecodes = ((uint8_t*)&self->fields[SEND(self, _get_offset) + 
			SEND(self, get_number_of_indexable_fields)
			]);
/*
		printf("offset: %d; indx: %d; bcs: %d\n", SEND(self, _get_offset),
			SEND(self, get_number_of_indexable_fields),
			SEND(self, get_number_of_bytecodes));
		printf("i: %d; tc: %d; val: %d\n",index, SEND(self, get_number_of_bytecodes), value);
	for (i = 0; i < SEND(self, get_number_of_bytecodes)+SEND(self, get_number_of_tcodes)*sizeof(void*);i++)
	{
		printf("byte%d: %d |", i, bytecodes[i]);
	}
	printf("\nput tcode at: %d\n",SEND(self, _get_offset) + 
        SEND(self, get_number_of_indexable_fields) +
		SEND(self, get_number_of_bytecodes)+index);
	*/
    ((void**)&(bytecodes[
		SEND(self, get_number_of_bytecodes)
    ]))[index] = value;
	
}
