#ifndef SCHEDULER_H
#define SCHEDULER_H

#include "vmobjects/VMFrame.h"

//runs the passed thread
void  Scheduler_run_thread(pVMObject thread, pVMFrame frame);
//saves the thread frame to the threadlist
void  Scheduler_register_thread_frame(pVMObject arg);
//removes thread frame from the thread list
void  Scheduler_unregister_thread_frame(pVMObject thread);
//puts the entire VM to sleep for the passed period of time
void  Scheduler_sleep(long duration);

//run the scheduler thread - no primitive - called from interpreter
void  Scheduler_run_scheduler_thread();

extern pVMClass scheduler_class;
void Scheduler_insert_scheduler();

extern size_t scheduler_return_count;

void Scheduler_enter_uninterruptable_section();
void Scheduler_leave_uninterruptable_section();

// exported for GC-Marksweep
typedef struct ThreadToFrameAssociation threadToFrameAssociation;

//Association between Smalltalk Thread Object and VM frame
struct ThreadToFrameAssociation {
	pVMObject thread;
	pVMFrame frame;
	threadToFrameAssociation* next;
};

// added for GC-Marksweep
threadToFrameAssociation* Scheduler_get_thread_frame_list();
pVMFrame Scheduler_get_scheduler_frame();
threadToFrameAssociation* Scheduler_get_scheduler_thread();
threadToFrameAssociation* Scheduler_get_current_thread();

extern bool Scheduler_firstRun;

#endif /*SCHEDULER_H*/
