#ifndef INTERPRETER_THREADED_H_
#define INTERPRETER_THREADED_H_

/*
 *
Copyright (c) 2007 Michael Haupt, Tobias Pape
Software Architecture Group, Hasso Plattner Institute, Potsdam, Germany
http://www.hpi.uni-potsdam.de/swa/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
  */

#include <module.VMObjects>

extern int interpreter_super_inst_config_mask;
extern void** pc;
extern void** pc_from_index(pVMMethod _method, int index);
extern int index_from_pc(pVMMethod _method, void** _pc);

void      Interpreter_threaded_init();
void      Interpreter_threaded_start(void);
pVMFrame  Interpreter_threaded_push_initial_frame(pVMMethod _method);
pVMFrame  Interpreter_threaded_push_new_frame(pVMMethod _method);
uint8_t   Interpreter_threaded_first_super_bc();
uint8_t   Interpreter_threaded_last_super_bc();
void	  Interpreter_threaded_set_frame(pVMFrame _frame);

void Interpreter_threaded_set_bytecode_index(int _bytecode_index);
int Interpreter_threaded_get_bytecode_index();

#define SUPER_INST_MAX_SEQUENCE_LENGTH 4
#define SUPER_INST_MAX 64
#define SUPER_INST_SEQUENCE_SENTINEL 0xFF

typedef struct {
    void* label;
    int length;
    uint8_t sequence[SUPER_INST_MAX_SEQUENCE_LENGTH+1];
} inst_handler_entry;

extern inst_handler_entry inst_handler_entries[SUPER_INST_MAX];

//extern int labelsInitialized;

#endif INTERPRETER_THREADED_H_
